unit MainForm;

interface

uses
  Winapi.Windows, Winapi.Messages, System.SysUtils, System.Variants, System.Classes, Vcl.Graphics,
  Vcl.Controls, Vcl.Forms, Vcl.Dialogs, AdvUtil, Vcl.Grids, AdvObj, BaseGrid, AdvGrid, Vcl.StdCtrls, Vcl.Themes,  Vcl.ExtCtrls;

type
  TMainfrm = class(TForm)
    DarkStyleBtn: TButton;
    LightStyleBtn: TButton;
    ColorCellsBtn: TButton;
    Grid1: TAdvStringGrid;
    procedure DarkStyleBtnClick(Sender: TObject);
    procedure LightStyleBtnClick(Sender: TObject);
    procedure ColorCellsBtnClick(Sender: TObject);
    procedure FormActivate(Sender: TObject);
  private
    procedure FillGrid(Grid: TAdvStringGrid);
    procedure ColorGrid(Grid: TAdvStringGrid);
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Mainfrm: TMainfrm;

implementation

{$R *.dfm}

//Redraw problems occur regardless of what named styles you use. Also occurs both when using different DPI aware settings
//I used Grid.UseFixedFont = false, but problems occur either way
//Try setting a theme, then coloring cells, then setting another theme


procedure TMainfrm.ColorGrid(Grid: TAdvStringGrid);

var
  r, c: integer;

begin
  for r := 2 to 5 do
    for c := 0 to 5 do //Screen refresh is OK if you don't try to color column 0  or row 0 (the fixed cols/rows)
       Grid.Colors[c,r] := clBlue;
end;

procedure TMainfrm.ColorCellsBtnClick(Sender: TObject);


begin
  ColorGrid(Grid1);
end;

procedure TMainfrm.DarkStyleBtnClick(Sender: TObject);
begin
  TStyleManager.TrySetStyle('Windows10 BlackPearl');
end;


procedure TMainfrm.FillGrid(Grid: TAdvStringGrid);

var
  r, c: integer;

begin
  Grid.ColCount := 11;
  Grid.RowCount := 11;
  Grid.FixedCols := 1;
  Grid.FixedRows := 1;
  for c := 1 to 10 do
    Grid.Cells[c, 0] := Format('Column %d', [c]);
  for r := 1 to 10 do
    Grid.Cells[0, r] := Format('Row %d', [r]);
  for r := 1 to 10 do
    for c := 1 to 10 do
      begin
        Grid.Cells[c, r] := FloatToStrF(Random(10), ffFixed, 15, 2);
        Grid.Alignments[c, r] := taRightJustify;
      end;
end;

procedure TMainfrm.FormActivate(Sender: TObject);

begin
  FillGrid(Grid1);
end;

procedure TMainfrm.LightStyleBtnClick(Sender: TObject);
begin
  TStyleManager.TrySetStyle('Windows10');
end;

end.
